/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ListContactCoupons200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ListContactCoupons200Response{}

// ListContactCoupons200Response struct for ListContactCoupons200Response
type ListContactCoupons200Response struct {
	Results []Coupon `json:"results"`
	Total int32 `json:"total"`
}

// NewListContactCoupons200Response instantiates a new ListContactCoupons200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListContactCoupons200Response(results []Coupon, total int32) *ListContactCoupons200Response {
	this := ListContactCoupons200Response{}
	this.Results = results
	this.Total = total
	return &this
}

// NewListContactCoupons200ResponseWithDefaults instantiates a new ListContactCoupons200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListContactCoupons200ResponseWithDefaults() *ListContactCoupons200Response {
	this := ListContactCoupons200Response{}
	return &this
}

// GetResults returns the Results field value
func (o *ListContactCoupons200Response) GetResults() []Coupon {
	if o == nil {
		var ret []Coupon
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *ListContactCoupons200Response) GetResultsOk() ([]Coupon, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *ListContactCoupons200Response) SetResults(v []Coupon) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *ListContactCoupons200Response) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *ListContactCoupons200Response) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *ListContactCoupons200Response) SetTotal(v int32) {
	o.Total = v
}

func (o ListContactCoupons200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ListContactCoupons200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableListContactCoupons200Response struct {
	value *ListContactCoupons200Response
	isSet bool
}

func (v NullableListContactCoupons200Response) Get() *ListContactCoupons200Response {
	return v.value
}

func (v *NullableListContactCoupons200Response) Set(val *ListContactCoupons200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableListContactCoupons200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableListContactCoupons200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListContactCoupons200Response(val *ListContactCoupons200Response) *NullableListContactCoupons200Response {
	return &NullableListContactCoupons200Response{value: val, isSet: true}
}

func (v NullableListContactCoupons200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListContactCoupons200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


